#include <vector>
#include <algorithm>
#include <cstdlib>
#include <cmath>
#include <iostream>

struct node_tree {
	node_tree() : left(NULL), right(NULL){}
	node_tree(node_tree* l, node_tree* r) : left(l), right(r) {}
	~node_tree() {
		delete left;
		delete right;
	}
	node_tree*	left;
	node_tree*	right;
	int val;
};

std::vector<int>	values;
int					index_v = 0;

node_tree	*construct_tree(int cur, int max) {
	node_tree*	ret;

	if (cur == max)
		return NULL;
	ret = new node_tree();
	ret->left = construct_tree(cur + 1, max);
	ret->right = construct_tree(cur + 1, max);
	return ret;
}

void	assign_keys(node_tree* root) {
	root->val = values[index_v];
	index_v += 1;
	if (root->left) {
		assign_keys(root->left);
		assign_keys(root->right);
	}
}

bool		test_chemin(node_tree* root) {
	return ((root->left == NULL) ||
			(root->left->val < root->val && test_chemin(root->left)) ||
			(root->right->val < root->val && test_chemin(root->right)));
}


int main(int ac, char **av) {
	int n, len, i;
	node_tree*	root;
	int	sum = 0, perms = 1;
	
	if (ac == 2)
	{
		n = std::atoi(av[1]);
		len = std::pow(2, n) - 1;
		for (i = 0; i < len; i++)
			values.push_back(i);
		root = construct_tree(0, n);
		assign_keys(root);
		index_v = 0;
		sum += test_chemin(root);
		while (std::next_permutation(values.begin(), values.end())) {
			assign_keys(root);
			perms+=1;
			index_v = 0;
			sum += (test_chemin(root) ? 1 : 0);
		}
		std::cout << "On a binary tree of depth " << n << ", there is " << sum
			<< " possible ways for all its "<< perms << " permutations." << std::endl;
	}
}
